## Copyright (C) 2022 t.bajraszewski
##
## This program is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program.  If not, see <https://www.gnu.org/licenses/>.

## -*- texinfo -*-
## @deftypefn {} {@var{retval} =} confusionmat (@var{input1}, @var{input2})
##
## @seealso{}
## @end deftypefn

## Author: https://wiki.octave.org/Talk:Statistics_package
## Created: 2022-02-21

function [ret] = confusionmat(v1, v2)
  values = union(unique(v1), unique(v2));
  ret = zeros(size(values), size(values));
  for i = 1:size(v1,1)
     i1 = find(values == v1(i));
     i2 = find(values == v2(i));
     ret(i1, i2) = ret(i1, i2) + 1;
  end
endfunction
