# This function generates C code with NN model
# Copyright: T. Bajraszewski
# email: tomasz@bajraszewski.pl
# 2023
function generate_c_code_header(filename, in, hid, out)

  fid = fopen(filename, 'w');

  fprintf(fid, "/******************************************************************\n");
  fprintf(fid, "        Start of NN defines, variables and data\n");
  bytes = (hid * (in + 1) + out * (hid + 1) + 9) * 4;
  fprintf(fid, "        Arduino resources usage:\n");
  fprintf(fid, "        > %d Bytes of PROGMEM space for NN weights and parameters\n", bytes);
  bytes = (in + hid) * 4;
  fprintf(fid, "        > %d Bytes of RAM space for variables\n", bytes);
  fprintf(fid, " ******************************************************************/\n");
  fprintf(fid, "\n");



  fprintf(fid, "typedef uint8_t uint8;\n");
  fprintf(fid, "\n");

  fprintf(fid, "#define N_INPUT_LAYERS %d\n", in);
  fprintf(fid, "#define N_HIDDEN_LAYERS %d\n", hid);
  fprintf(fid, "#define N_LABELS %d\n", out);
  fprintf(fid, "\n");

  fprintf(fid, "float __nn_a2[N_HIDDEN_LAYERS + 1]; /*+1 to include bias term*/ \n");
  fprintf(fid, "float __nn_X[N_INPUT_LAYERS + 1];  /*+1 to include bias term*/ \n");
  fprintf(fid, "\n");

  fclose(fid);

endfunction
