function [p, a3] = predict(Theta1, Theta2, X, mu, sigma, wbc)
%PREDICT Predict the label of an input given a trained neural network
%   p = PREDICT(Theta1, Theta2, X) outputs the predicted label of X given the
%   trained weights of a neural network (Theta1, Theta2)
%   wb - white balance coefficients

% Useful values
m = size(X, 1);
num_labels = size(Theta2, 1);

Xnorm = (X - mu) ./ sigma;
% here data are already white-balanced
% but in Arduino implementation, you should white balanced it
% using formula
% Xnorm = (X - mu) .* wbc ./ sigma;

% You need to return the following variables correctly
p = zeros(size(X, 1), 1);

a2 = sigmoid([ones(m, 1) single(Xnorm)] * single(Theta1)');

h3 = [ones(m, 1) single(a2)] * single(Theta2)';

a3 = sigmoid(single(h3));


[dummy, p] = max(a3, [], 2);

% =========================================================================


endfunction
